#include <iostream>
#include <sstream>
#include <thread>
#include <mutex>
#include <vector>
#include <unistd.h>

class Compteur{
  int val;
  std::mutex m;
public:
  Compteur(int v=0);
  void add(int v=1);
  void sub(int v=1);
  int get();
};

Compteur::Compteur(int v) : val(v), m() {
}

void
Compteur::add(int v) {
  std::unique_lock<std::mutex> lck(m);
  val += v;
}
void
Compteur::sub(int v){
  std::unique_lock<std::mutex> lck(m);
  val -= v;
}

int
Compteur::get(){
  // le lock est inutile car la valeur renvoyée est toujours cohérente.
  return val;
}

using namespace std;

void
fct_th(int num, int nbtour, Compteur &cpt) {
  int i;
  ostringstream m;
  m << "Je sui le thread " << num << nbtour<<endl;
  cout << m.str();

  // j'attend 1 seconde que tout le monde soit arrivé.
  usleep(1000000);
  
  for (i=0; i<nbtour; i++) {
    usleep(rand()%1000);
    cpt.add();
  }

  
}


int main(int argc, char*argv[]) {
  int i;
  int nbth = 5;
  int nbtour = 100;

  if (argc >= 2) {
    nbth = atoi(argv[1]);
  }
  if (argc >= 3) {
    nbtour = atoi(argv[2]);
  }

  cerr << "Lancement du programme avec " << nbth << " threads qui font "
       << nbtour << " ajouts" << endl;

  Compteur cpt;
  vector<thread> tab;
  
  for (i = 0; i < nbth; i++) {
    tab.push_back(thread(fct_th, i, nbtour, std::ref(cpt)));
  }

  for (i=0; i<nbth; i++) {
    ostringstream m;
    tab[i].join();
    
    m << "Fin du thread " << i << endl;
    cerr << m.str();
  }

  cerr << "Après la fin des threads le compteur est " << cpt.get() << endl;
  cerr << "Taux réussite : " << cpt.get()*1.0/(nbth*nbtour)*100 <<"%" << endl;

  return 0;
}
